#include <bits/stdc++.h>

using namespace std;

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0); cout.tie(0);
    int t,n,m,x,a;
    cin>>t;
    while(t--){
        cin>>n>>m;
        cin>>x;
        for(int i=1;i<n;i++){
            cin>>a;
            x=__gcd(x,a);
        }
        for(int i=0;i<m;i++){
            cin>>a;
            if(a%x==0){
                cout<<"0\n";
                break;
            }
            if(i==m-1)
                cout<<"1\n";
        }
    }
    return 0;
}